/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)generic.h	2.1.5 (Berkeley) 1/4/92
 */

#ifndef _GENERIC_INC_
#define _GENERIC_INC_

#define _PASTE2(x, y)          _PASTE2_x(x, y)
#define _PASTE2_x(x, y)        x##y
#define _PASTE3(x, y, z)       _PASTE3_x(x, y, z)
#define _PASTE3_x(x, y, z)     x##y##z
#define _PASTE4(w, x, y, z)    _PASTE4_x(w, x, y, z)
#define _PASTE4_x(w, x, y, z)  w##x##y##z

#define _ALT_PASTE2(x, y)          _ALT_PASTE2_x(x, y)
#define _ALT_PASTE2_x(x, y)        x##y
#define _ALT_PASTE3(x, y, z)       _ALT_PASTE3_x(x, y, z)
#define _ALT_PASTE3_x(x, y, z)     x##y##z
#define _ALT_PASTE4(w, x, y, z)    _ALT_PASTE4_x(w, x, y, z)
#define _ALT_PASTE4_x(w, x, y, z)  w##x##y##z

// macros for the declaration and implementation of classes
#define declare(x, y)       _PASTE2(x, declare)(y)
#define implement(x, y)     _PASTE2(x, implement)(y)
#define declare2(x, y, z)   _PASTE2(x, declare2)(y, z)
#define implement2(x, y, z) _PASTE2(x, implement2)(y, z)

// macros for the declaration of error-handling functions

extern genericerror(int, char*);
typedef int (*GPT)(int, char*);
#define set_handler(generic, type, x)  _PASTE4(set_, type, generic, _handler)(x)
#define errorhandler(generic, type)    _PASTE3(type, generic, handler)
#define callerror(generic, type, x, y) (*errorhandler(generic, type))(x, y)

#define name2(x, y) _ALT_PASTE2_x(x, y)
#define name3(x, y, z) _ALT_PASTE3_x(x, y, z)
#define name4(w, x, y, z) _ALT_PASTE4_x(w, x, y, z)

#endif
